// Author: Pete Kirkham
//
// quad store utils.
//
#ifndef _TRIPLE_IMPORTER_H_
#define _TRIPLE_IMPORTER_H_

#import "utils/string_table.h"
#import "core/triple_target.h"

class triple_importer : public triple_target
{
public:
    triple_importer (string_table& table) : _table(table) { }

    virtual void add_triple (const char* subject,   size_t subject_length,   field_type subject_type,
                             const char* predicate, size_t predicate_length, // always an uri
                             const char* object,    size_t object_length,    field_type object_type,
                             unsigned int graph_id)
    {
        unsigned int s(_table.put(subject,   subject_length));
        unsigned int p(_table.put(predicate, predicate_length));
        unsigned int o(_table.put(object,    object_length));

        std::cout << "</" << s << "," << p << "," << o << "," << graph_id << "/>" << std::endl;
    }

private:
    string_table&   _table;
};

#endif // _TRIPLE_TARGET_H_
